<?php
/*header('Content-type: application/json; charset=utf-8');
header("Access-Control-Allow-Credentials: false");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET,HEAD,OPTIONS,POST,PUT");
header("Access-Control-Allow-Headers: *");*/

require __DIR__.'/../vendor/autoload.php';
require __DIR__.'/../vendor/zeedhi/framework/bootstrap.php';
require __DIR__ . "/../vendor/teknisa/libraries-next/scripts/bootstrap.php";

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$environment = __DIR__.'/../../../../backend/config/environment.xml';
$dbXmlProduct = __DIR__.'/../../../../backend/config/db.xml';
$report = __DIR__ . "/../config/report.xml";
$parameters = __DIR__.'/../../../../backend/config/parameters.xml';
$general = __DIR__.'/../../../../backend/config/general.xml';


if (realpath($parameters)) {
    $instanceManager->loadFromFile($parameters);
}

$container = $instanceManager->getContainer();

$routes = array();
$routes[] = __DIR__ . '/vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . "/vendor/zeedhi/preferences/routes.json";
$routes[] = __DIR__ . '/config/routes.json';
$routes[] = __DIR__ . "/vendor/zeedhi/preferences/routes.json";

if ($container->hasParameter('use_zhu_acl') && $container->getParameter('use_zhu_acl')){
    $acl = __DIR__ . '/../../acl/backend/config/acl.xml';
    if(realpath($acl)){
        $instanceManager->loadFromFile($acl);
    }
}

if ($container->hasParameter('use_zhu_update') && $container->getParameter('use_zhu_update') == 'true'){
    $zhu = __DIR__ . '/../../acl/backend/config/zhuUpdate.xml';

    if(realpath($zhu)){
        $instanceManager->loadFromFile($zhu);
    }
}

if ($container->hasParameter('use_zhu_log') && $container->getParameter('use_zhu_log')) {
    $zhuDateFormat = $container->getParameter('zhuLogDateFormat');
    $ignoredRoutes = $container->hasParameter('logIgnoredRoutes') ? $container->getParameter('logIgnoredRoutes') : [];

    require __DIR__ . "/vendor/zeedhi/zhulog/config/bootstrap.php";
    $routes[] = __DIR__."/vendor/zeedhi/zhulog/config/routes.json";

    $log = __DIR__.'/../../acl/backend/config/log.xml';
    if(realpath($log)){
        $instanceManager->loadFromFile($log);
    }

    $libLog = __DIR__.'/vendor/teknisa/libraries/zhuLog.xml';
    if(realpath($libLog)){
        $instanceManager->loadFromFile($libLog);
    }

    $container->setParameter('logIgnoredRoutes', $ignoredRoutes);
    $container->setParameter('zhuLogDateFormat', $zhuDateFormat);
}

if(!realpath($dbXmlProduct)) {
    $dbXmlProduct = __DIR__ . "/config/db.xml";
}
if(!realpath($report)) {
    $report = __DIR__.'/../../../../backend/config/report.xml';
}
if (realpath($general)){
    $instanceManager->loadFromFile($general);
}

if(realpath($environment))
    $instanceManager->loadFromFile($environment);

$instanceManager->loadFromFile($dbXmlProduct);
$instanceManager->loadFromFile(__DIR__ . '/../config/environment.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/util.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/controllers.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/parameters.xml');
$instanceManager->loadFromFile(__DIR__ . '/../config/services.xml');
if(realpath($report)) {
    $instanceManager->loadFromFile($report);
}

$routes = array();
$routes[] = __DIR__ . '/../config/routes.json';
$routes[] = __DIR__ . '/../vendor/teknisa/libraries-next/libRoutes.json';


$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();

/** @var \Zeedhi\Framework\Application $app */
$app = $instanceManager->getService('application');
$app->run();
