<?php
namespace GopNext\Services;

class OperatingBudgetParametersService{
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
   }
   
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
      $this->connection->rollback();
    }
   
    public function reciveParametersForBudgetOperation(){
        $query = "SELECT * FROM PARAMORCAOPERAC";
        try {
            $std = $this->connection->prepare($query);
            $std->execute();
            $result = $std->fetchAll();
            return $result;
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function insertGeneral($params) {
        $query = 
                  "INSERT INTO PARAMORCAOPERAC (
            IDTIPOSIMULARESULTFAT, IDUTILMESBASE, CDTIPOCUSTO, CDINDICECON,
            CDINDICEFAT,IDORCDESPDIVERS, IDORCADESPMATRI, IDORCDESPENTROP, NRDIALIMITEORCA, IDPERORCAITEMDETAL, IDUTILVERSAOORCA, IDAPROVORCACONC,
            IDCALCFATUROP, NRDIAANTELABORCA, IDUTILORCAREALOC, IDCONSORCREALOC, IDPERIODOORCA, IDREALINFORCA, IDREALSUPORCA, NRDIAINIORCA, NRMESINIORCA
        ) VALUES (
            :IDTIPOSIMULARESULTFAT, :IDUTILMESBASE, :CDTIPOCUSTO, :CDINDICECON, :CDINDICEFAT, :IDORCDESPDIVERS, :IDORCADESPMATRI,
            :IDORCDESPENTROP, :NRDIALIMITEORCA, :IDPERORCAITEMDETAL, :IDUTILVERSAOORCA, :IDAPROVORCACONC, :IDCALCFATUROP, :NRDIAANTELABORCA, 
            :IDUTILORCAREALOC, :IDCONSORCREALOC, :IDPERIODOORCA, :IDREALINFORCA, :IDREALSUPORCA, :NRDIAINIORCA, :NRMESINIORCA)";
        try {
            $stmt = $this->connection->prepare($query);
            $stmt->execute($params);
        } catch (Exception $ex){
            throw $ex;
        }
    }
    
    public function updateOpBudgetParamsOperation($params) {
        $query = 
        "UPDATE PARAMORCAOPERAC
            SET
                IDTIPOSIMULARESULTFAT = :IDTIPOSIMULARESULTFAT,
                IDUTILMESBASE = :IDUTILMESBASE,
                CDTIPOCUSTO = :CDTIPOCUSTO,
                CDINDICECON = :CDINDICECON,
                CDINDICEFAT = :CDINDICEFAT,
                IDORCDESPDIVERS = :IDORCDESPDIVERS,
                IDORCADESPMATRI = :IDORCADESPMATRI,
                IDORCDESPENTROP = :IDORCDESPENTROP,
                NRDIALIMITEORCA = :NRDIALIMITEORCA,
                IDPERORCAITEMDETAL = :IDPERORCAITEMDETAL,
                IDUTILVERSAOORCA = :IDUTILVERSAOORCA,
                IDAPROVORCACONC = :IDAPROVORCACONC,
                IDCALCFATUROP = :IDCALCFATUROP,
                NRDIAANTELABORCA = :NRDIAANTELABORCA,
                IDUTILORCAREALOC = :IDUTILORCAREALOC,
                IDCONSORCREALOC = :IDCONSORCREALOC,
                IDPERIODOORCA = :IDPERIODOORCA,
                IDREALINFORCA = :IDREALINFORCA,
                IDREALSUPORCA = :IDREALSUPORCA,
                NRDIAINIORCA = :NRDIAINIORCA,
                NRMESINIORCA = :NRMESINIORCA
            WHERE
                CDPARORCAOPERAC = '00001'";
            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        };
    }
    
    public function updateOpBudgetParamsUnit($params) {
        $query = 
        "UPDATE FILIAL
        SET
            NRMESREAJCONTR = :NRMESREAJCONTR,
            VRPEORCBLOQFIL = :VRPEORCBLOQFIL,
            VRPEORCALERTFIL = :VRPEORCALERTFIL,
            IDCALCOMESTORC = :IDCALCOMESTORC,
            IDCONSAPENCARDAPROV = :IDCONSAPENCARDAPROV,
            NRDIAINIORCAGOP = :NRDIAINIORCAGOP,
            IDUTILPERCFILGOP = :IDUTILPERCFILGOP
        WHERE
            CDFILIAL = :CDFILIAL";
            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            $result = $stmt->fetchAll();
            return $result;
        } catch (Exception $e){
            throw $e;
        };
    }

    public function insertOperationalItem($params) {
        $query =
            " INSERT INTO ITEMOPERACIONAL (
                NRITEMOPERACIONAL,
                IDTIPOORCAOP,
                IDCHECK
            ) VALUES (
                :NRITEMOPERACIONAL,
                :IDTIPOORCAOP,
                :IDCHECK)";
        try{
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function updateBudgetParamsRegister($params) {
        $query = 
        "UPDATE FILIAL
        SET
            NRMESREAJCONTR = :NRMESREAJCONTR,
            VRPEORCBLOQFIL = :VRPEORCBLOQFIL,
            VRPEORCALERTFIL = :VRPEORCALERTFIL,
            IDCALCOMESTORC = :IDCALCOMESTORC,
            NRDIAINIORCAGOP = :NRDIAINIORCAGOP,
            IDCONSAFORCFIL = :IDCONSAFORCFIL
        WHERE
            CDFILIAL = :CDFILIAL";
            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        };
    }

        public function updateOpBudgetParamsItem($params) {
        $query = 
        "UPDATE ITEMOPERACIONAL
                          SET IDCHECK = CASE WHEN INSTR(:NRITEMOPERACIONAL,'_'||NRITEMOPERACIONAL||'_') > 0
                                THEN 'S'
                                ELSE 'N'
                             END";
            
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        };
    }
}