<?php
namespace GopNext\Services;

class OperationalBudgetApprovalService {
  
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function beginTransaction() {
        $this->connection->beginTransaction();
    }
    
    public function commit() {
        $this->connection->commit();
    }
    
    public function rollback() {
        $this->connection->rollback();
    }
    
    public function insertNewAprovation($params) {
        $sqlInsert = "
                     INSERT INTO
                        APROVAORCAGOP 
                    (
                        NRORCAMENTOGOP,
                        NRAPROVAORCAGOP,
                        CDOPERADOR,
                        IDAPROVACAOGOP,
                        DSOBSERVACAO,
                        DTINCLUSAO,
                        CDOPERINCLUSAO,
                        IDTIPOORCAOP
                     ) 
                    VALUES(
                        :P_NRORCAMENTOGOP,
                        SEQ_APROVAORCAGOP.NEXTVAL,
                        :P_CDOPERADOR,
                        :P_IDAPROVACAOGOP,
                        :P_DSOBSERVACAO,
                        SYSDATE,
                        :P_CDOPERINCLUSAO,
                        :P_IDTIPOORCAOP
                    )";
        try{
            $std = $this->connection->prepare($sqlInsert);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function updateAprovationStatus($params) {
        $sqlUpdate = " UPDATE APROVAORCAGOP
                          SET IDAPROVACAOGOP = :P_IDAPROVACAOGOP,
                              DSOBSERVACAO = :P_DSOBSERVACAO,
                              DTULTATU = SYSDATE,
                              NRORGULTATU = :P_NRORGULTATU,
                              CDOPERULTATU = :P_CDOPERULTATU
                        WHERE NRAPROVAORCAGOP = :P_NRAPROVAORCAGOP";
        try{
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
    
    public function updateConclusaoStatus($params) {
        $sqlUpdate = "UPDATE CONCPREORCAGOP
                         SET IDSTATUS = :P_IDSTATUS,
                             DSOBSERVACAO = :P_DSOBSERVACAO
                       WHERE CDFILIAL = :P_CDFILIAL
                         AND NRCONCPREORCAGOP = :P_NRCONCPREORCAGOP";

        try{
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        }catch(Exception $e) {
            throw $e;
        }
    }
}
