import {
  Http,
} from '@zeedhi/core';
import {
  LoadingService,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';

export class OperatingBudgetConclusionController {
  public async completeBudget(data): Promise<void> {
    const utilities = new Utilities();
    
    try {
      LoadingService.show();
      
      const response = await Http.post('/completeBudget', data);
      
      if (response.data.error) {
        throw new Error(response.data.error);
      }
      
      utilities.successMessage();
      utilities.hideDialogue();
    } catch (e) {
      utilities.errorMessage();
      console.warn(e);
    } finally {
      LoadingService.hide();
    }
  }
}
