import Vue from 'vue';
import { Messages, Metadata } from '@zeedhi/core';
import App from './App.vue';
import { vuetify } from './plugins';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.config.productionTip = false;
const loadMessages = async () => {
  const messages = await Metadata.get('json/messages', true);
  const wordsEsCl = await Metadata.get('json/words/es_cl', true);
  const wordsEnUs = await Metadata.get('json/words/en_us', true);

  Messages.add({
    'pt-BR': {
      translation: {
        ...messages,
      },
    },
    'es-CL': {
      translation: {
        ...wordsEsCl,
      },
    },
    'en-US': {
      translation: {
        ...wordsEnUs,
      },
    },
  });
};

loadMessages().then(() => {
  new Vue({
    vuetify,
    render: (h) => h(App),
  }).$mount('#app');
});
